using System;
using System.Runtime.InteropServices;

namespace SIOStablo
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            string[,] niz = new string[n, 3]; int brs = 0, bri = 0, bro = 0;
            int[] pozicije_s = new int[n];
            int[] pozicije_i = new int[n];
            int[] pozicije_o = new int[n];
            int sio = 0;
            for (int i = 0; i < n - 1; i++)
            {
                string[] o = Console.ReadLine().Split();
                niz[i, 0] = o[0];
                niz[i, 1] = o[1];
                niz[i, 2] = o[2];
                if (o[2] == "S") { pozicije_s[brs] = i; brs++; }
                if (o[2] == "I") { pozicije_i[bri] = i; bri++; }
                if (o[2] == "O") { pozicije_o[bro] = i; bro++; }
            }

            for (int i = 0; i < brs; i++)
            {
                for(int j = 0; j < bri; j++)
                {
                   /* if(niz[pozicije_s[i], 0] == niz[pozicije_i[j], 0]
                        || niz[pozicije_s[i], 0] == niz[pozicije_i[j], 1]
                        || niz[pozicije_s[i], 1] == niz[pozicije_i[j], 0]
                        || niz[pozicije_s[i], 1] == niz[pozicije_i[j], 1] ) 
                    {
                        for(int k = 0; k < bro; k++)
                        {
                            if (niz[pozicije_o[k], 0] == niz[pozicije_i[j], 0]
                        || niz[pozicije_o[k], 0] == niz[pozicije_i[j], 1]
                        || niz[pozicije_o[k], 1] == niz[pozicije_i[j], 0]
                        || niz[pozicije_o[k], 1] == niz[pozicije_i[j], 1])
                            {
                                sio++;
                            }
                        }
                    } */
                    if (niz[pozicije_s[i], 0] == niz[pozicije_i[j], 0])
                    {
                        for (int k = 0; k < bro; k++)
                        {
                            if (
                           niz[pozicije_o[k], 0] == niz[pozicije_i[j], 1]
                        || niz[pozicije_o[k], 1] == niz[pozicije_i[j], 0]
                        || niz[pozicije_o[k], 1] == niz[pozicije_i[j], 1])
                            {
                                sio++;
                            }
                        }
                    }
                    if(niz[pozicije_s[i], 0] == niz[pozicije_i[j], 1])
                    {
                        for (int k = 0; k < bro; k++)
                        {
                            if (niz[pozicije_o[k], 0] == niz[pozicije_i[j], 0]
                        
                        || niz[pozicije_o[k], 1] == niz[pozicije_i[j], 0]
                        || niz[pozicije_o[k], 1] == niz[pozicije_i[j], 1])
                            {
                                sio++;
                            }
                        }
                    }
                    if (niz[pozicije_s[i], 1] == niz[pozicije_i[j], 0])
                    {
                        for (int k = 0; k < bro; k++)
                        {
                            if (niz[pozicije_o[k], 0] == niz[pozicije_i[j], 0]
                        || niz[pozicije_o[k], 0] == niz[pozicije_i[j], 1]
                        
                        || niz[pozicije_o[k], 1] == niz[pozicije_i[j], 1])
                            {
                                sio++;
                            }
                        }
                    }
                    if(niz[pozicije_s[i], 1] == niz[pozicije_i[j], 1])
                    {
                        for (int k = 0; k < bro; k++)
                        {
                            if (niz[pozicije_o[k], 0] == niz[pozicije_i[j], 0]
                        || niz[pozicije_o[k], 0] == niz[pozicije_i[j], 1]
                        || niz[pozicije_o[k], 1] == niz[pozicije_i[j], 0] )
                        
                            {
                                sio++;
                            }
                        }
                    }
                }
            }

            Console.WriteLine(sio);

        }
    }
}